/*
 *	AskTo library.  A very basic preparse system to translate "ask/tell bob 
 *	to open the door" into "bob, open the door".
 *
 *	Copyright (c) 2003 by Quintin Stone.  All Rights Reserved.
 */

preparse: function(str) {
	local tokenList, tokenType, tokenOne;
	tokenList := parserTokenize(str);
	if (tokenList = nil)
		return true;
	if (length(tokenList) = 0)
		return true;
	tokenOne := tokenList[1];
	tokenType := parserGetTokTypes([tokenOne]);
	if (tokenType != [] && intersect([PRSTYP_VERB], tokenType) != []) {
		local verbMatch;
		verbMatch := parserDictLookup([tokenOne], [PRSTYP_VERB]);
		if (verbMatch = [])
			return true;
		if ((verbMatch[1] = askVerb) || (verbMatch[1] = tellVerb)) {
			local count, targetList, target, targetname, typeList, i, word;
			for (count := 2; count <= length(tokenList) && tokenList[count] != 'to' && tokenList[count] != 'about'; count++) {
			}
			if ((count < length(tokenList)) && (tokenList[count] = 'to')) {
				targetList := [];
				targetname := '';
				typeList := [];
				for (i := 2; i < count; i++) {
					word := tokenList[i];
					targetList += [word];
					targetname += ' ' + word;
					typeList += parserGetTokTypes([word]);
				}
				targetname := substr(targetname, 2, length(targetname));
				target := parseNounList(targetList, typeList, 1, true, nil, nil);
				if (target != nil) {
					local endstr;
					endstr := targetname + ',';
					for (i := count+1; i <= length(tokenList); i++) {
						endstr += ' ' + tokenList[i];
					}
					return endstr;
				}
			}
		}
	}
	return true;
}
