/*
 *	Throwdir library.  Enables the player to throw objects in a specific
 *	direction.  Initially created to support a grenade object.
 */

modify thing
	genThrowDirAction(actor, dir) = {
		local stat, loc, str;
		stat := outcapture(true);
		loc := actor.location.(dir);
		while (loc != nil && loc.isobstacle)
			loc := loc.destination;
		outcapture(stat);

		// Verification phase
		if (loc = nil) {
			"You can't throw <<self.thedesc>> in that direction. ";
			return;
		}
		if (self.weight > 10) {
			"\^<<self.thedesc>> is too heavy to throw that far. ";
			return;
		}
		if (self.weight < 2) {
			"\^<<self.thedesc>> is too light to throw that far. ";
			return;
		}

		if (dir = &up) {
			"\^<<self.thedesc>> sails up into the air. ";
		} else if (dir = &down) {
			"\^<<self.thedesc>> sails downward. ";
		} else {
			"\^<<self.thedesc>> sails throw the air to the ";
			switch (dir) {
				case &north:
					"north"; break;
				case &south:
					"south"; break;
				case &east:
					"east"; break;
				case &west:
					"west"; break;
				case &ne:
					"northeast"; break;
				case &nw:
					"northwest"; break;
				case &sw:
					"southwest"; break;
				case &se:
					"southeast"; break;
				default:
					"unknown direction"; break;
			}
			". ";
		}
		self.moveInto(loc);
		informActors(parserGetMe(), self, 4);
	}
	verDoThrowN(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowN(actor) = { self.genThrowDirAction(actor, &north); }
	verDoThrowS(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowS(actor) = { self.genThrowDirAction(actor, &south); }
	verDoThrowE(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowE(actor) = { self.genThrowDirAction(actor, &east); }
	verDoThrowW(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowW(actor) = { self.genThrowDirAction(actor, &west); }
	verDoThrowNE(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowNE(actor) = { self.genThrowDirAction(actor, &ne); }
	verDoThrowNW(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowNW(actor) = { self.genThrowDirAction(actor, &nw); }
	verDoThrowSE(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowSE(actor) = { self.genThrowDirAction(actor, &se); }
	verDoThrowSW(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowSW(actor) = { self.genThrowDirAction(actor, &sw); }
	verDoThrowUp(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowUp(actor) = { self.genThrowDirAction(actor, &up); }
	verDoThrowDown(actor) = { self.verDoThrowAt(actor, nil); }
	doThrowDown(actor) = { self.genThrowDirAction(actor, &down); }
;

throwNVerb: deepverb
	verb = 'throw north' 'throw n'
	sdesc = "throw north"
	doAction = 'ThrowN'
;

throwSVerb: deepverb
	verb = 'throw south' 'throw s'
	sdesc = "throw south"
	doAction = 'ThrowS'
;

throwEVerb: deepverb
	verb = 'throw east' 'throw e'
	sdesc = "throw east"
	doAction = 'ThrowE'
;

throwWVerb: deepverb
	verb = 'throw west' 'throw w'
	sdesc = "throw west"
	doAction = 'ThrowW'
;

throwNEVerb: deepverb
	verb = 'throw northeast' 'throw ne'
	sdesc = "throw northeast"
	doAction = 'ThrowNE'
;

throwNWVerb: deepverb
	verb = 'throw northwest' 'throw nw'
	sdesc = "throw northwest"
	doAction = 'ThrowNW'
;

throwSEVerb: deepverb
	verb = 'throw southeast' 'throw se'
	sdesc = "throw southeast"
	doAction = 'ThrowSE'
;

throwSWVerb: deepverb
	verb = 'throw southwest' 'throw sw'
	sdesc = "throw southwest"
	doAction = 'ThrowSW'
;

throwUpVerb: deepverb
	verb = 'throw up' 'throw u'
	sdesc = "throw up"
	doAction = 'ThrowUp'
;

throwDownVerb: deepverb
	verb = 'throw down' 'throw d'
	sdesc = "throw down"
	doAction = 'ThrowDown'
;
